/*___________________________________________________
                    W O R K I N G   W I T H   Q U E U E S

                                       Ron Kessler
                                Created 10/30/2016

Shows how to create a QUEUE data structure.
The items in the queue are FIFO. First in first off.

This project shows how to work with a queue which 
is just like a waiting list at your doctors office.

I am adding items to my queue using Enqueue. I show how
to use the Peek method to see if there are items still in the queue.
Then I use Dequeue to remove the item from the queue.

This time, Dog is the first item I add to the queue (wait list) and will
be the FIRST item removed from the queue.

Use F5 to run the demo.
___________________________________________________
*/

#include "stdafx.h"

using namespace System;
using namespace System::Collections::Generic;

int main(array<System::String ^> ^args)
{
	//---create a new Queue structure and Enqueue items onto it. 
	Queue<String^>^ waitList = gcnew Queue<String^>();

	waitList->Enqueue("Danny");			//first item in, first one out!
	waitList->Enqueue("Jeff");
	waitList->Enqueue("Karen");
	waitList->Enqueue("Juan");
	waitList->Enqueue("Rene");
	waitList->Enqueue("Alfredo");
	waitList->Enqueue("Chung");
	waitList->Enqueue("Amad");		//last item in, last one out: FIFO

	Console::WriteLine("Inital queue count is : " + waitList->Count + "\n\n");

	while (waitList->Count > 0)
	{
		String^ nextPatient = waitList->Peek();		//get next person in line without deleting them

		Console::WriteLine("Now serving " + nextPatient);
		
		//---now actually delete the person from the list and display message
		waitList->Dequeue();
		Console::WriteLine("Deleted " + nextPatient + " from the waiting list.");

		Console::WriteLine("Now the waiting list count is : " + waitList->Count + "\n");
			

	}

	Console::ReadKey();
	return 0;
}
